from edison_dictionary_api import EdisonBaseAPI


class sentimentsAutoKeywordsController(EdisonBaseAPI):
    """Sentiments autogenerated keywords"""

    _controller_name = "sentimentsAutoKeywordsController"

    def list(self, sentimentLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sentimentLanguageId: (string): sentimentLanguageId
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        api_parameters = ['sentimentLanguageId', '**kwargs']
        parameters_names_map = {}
        api = '/sentiments-auto-keywords/list'
        actions = ['post']
        params = self._format_params_for_api(locals(), api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params)

    def listForAllSentiments(self, **kwargs):
        """

        Args:
            languageId: (string): languageId
            minLevel: (number): minLevel

        Returns:
            application/json;charset=UTF-8
        """

        api_parameters = ['**kwargs']
        parameters_names_map = {}
        api = '/sentiments-auto-keywords/listForAllSentiments'
        actions = ['post']
        params = self._format_params_for_api(locals(), api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params)
